using System;
using Syncfusion.Windows.Forms.Grid;

namespace VirtDnDSample
{
	/// <summary>
	/// Summary description for VirtGrid.
	/// </summary>
	public class VirtGrid : GridControl
	{
		public VirtData theData = null;

		public VirtGrid()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		protected override void OnQueryCellInfo(Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(this.theData == null)
				return;
			base.OnQueryCellInfo(e);
			if(!e.Handled)
				e.Style.CellValue = this.theData[e.RowIndex, e.ColIndex];
		}

		protected override void OnSaveCellInfo(Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(this.theData == null)
				return;
			base.OnSaveCellInfo(e);
			if(!e.Handled)
			{
				this.theData[e.RowIndex, e.ColIndex] = e.Style.CellValue;
//				if(this.theData[e.RowIndex, e.ColIndex] != null)
//				{
//					Console.WriteLine(this.Text + "-->" + this.theData[e.RowIndex, e.ColIndex].ToString());
//				}
//				else
//				{
//					Console.WriteLine(this.Text + "--> null");
//				}
			}
		
		}

		protected override void OnQueryRowCount(Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			if(this.theData == null)
				return;

			base.OnQueryRowCount(e);
			if(!e.Handled)
			{
				e.Count = this.theData.RowCount;
				e.Handled = true;
			}
		}

		protected override void OnQueryColCount(Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			if(this.theData == null)
				return;
			base.OnQueryRowCount(e);
			if(!e.Handled)
			{
				e.Count = this.theData.ColCount;
				e.Handled = true;
			}
		}

		protected override void OnColWidthsChanged(Syncfusion.Windows.Forms.Grid.GridRowColSizeChangedEventArgs e)
		{
			base.OnColWidthsChanged(e);
			 
			
		}

		int[] m_ColumnSize = new int[100];
		protected override void OnColWidthsChanging(Syncfusion.Windows.Forms.Grid.GridRowColSizeChangingEventArgs e)
		{
			base.OnColWidthsChanging(e);

			for (int ix = e.From; ix <= e.To; ix++)
			{ 
				m_ColumnSize[ix] = e.Values[ix - e.From];
				e.Cancel = true;
				this.Refresh();
			}
		}

		int a = 0; //just to show something in teh output window
		protected override void OnQueryColWidth(Syncfusion.Windows.Forms.Grid.GridRowColSizeEventArgs e)
		{
			if(m_ColumnSize[e.Index] != 0)
			{
				Console.WriteLine("using m_ColumnSize {0} {1}", e.Index, a);
				a++;
				e.Handled = true;
				e.Size = m_ColumnSize[e.Index];
			}
			else
				base.OnQueryColWidth(e);
		}
	}

	public class VirtData
	{
		private object[,] values;
		private int rows;
		private int cols;

		
		public VirtData(int rows, int cols)
		{
			values = new object[rows, cols];
			this.rows = rows;
			this.cols = cols;
		}

		public int RowCount
		{
			get{return this.rows;}
			set{this.rows = value;}
		}

		public int ColCount
		{
			get{return this.cols;}
			set{this.cols = value;}
		}

		public object this[int row, int col]
		{
			get
			{
				if(row <= this.rows && col <= this.cols && row > 0 && col > 0)
				{
					return this.values[row - 1, col - 1];
				}
				else
					return null;
			}

			set
			{
				if(row <= this.rows && col <= this.cols && row > 0 && col > 0)
				{
					this.values[row - 1, col - 1] = value;
				}				
			}
		}

		public static void InitDummyData(VirtData data)
		{
			Random r = new Random();
			for(int i = 0; i < data.RowCount; ++ i)
				for(int j = 0; j < data.ColCount; ++j)
					data[i, j] = r.Next(10000);
		}

	}
}
